using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace entity.Forms
{
    public partial class ChunkClonerWindow : Form
    {
        int TagNumber;

        MetaSplitter metasplit;
        public bool result = false;
      
        int mapnumber;
        #region Constructor
        public ChunkClonerWindow(int tagnum,int mapnumberx)
        {
            mapnumber = mapnumberx;
            TagNumber = tagnum;
       
       
            InitializeComponent();
            SplitIFP();
            TreeNode tn = new TreeNode("Header");
    
            DisplaySplit(metasplit.Header,tn);
            tn.Expand();
            tn.Nodes[0].Expand();
            treeView1.Nodes.Add(tn);

        }
        #endregion



        #region Events
        private void chunkamount_TextChanged(object sender, EventArgs e)
        {
            try
            {
                int.Parse(chunkamount.Text);
            }
            
            catch
            {
                int ee = 0;
                chunkamount.Text = (ee ).ToString() ;
            }
        }
        #endregion

        public void FindSelectedNode(MetaSplitter.SplitReflexive reflex,TreeNode tn)
        {
            if (reflex.ChunkResources.Count == 0 && reflex.Chunks.Count == 0) { return; }
            int refcount = 0;
            foreach (TreeNode node in tn.Nodes)
            {
                if (node == treeView1.SelectedNode)
                {
                if (reflex.splitReflexiveType== MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    ChunkAdder.ChunkClipBoard = reflex.Chunks[refcount];
                    return;
                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk )
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            ChunkAdder.ChunkClipBoard = (MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount];
                             //ChunkAdder.ChunkClipBoard=(MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount];
                             return;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
              
                }
               }
        
                if (reflex.splitReflexiveType== MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    FindSelectedNode((MetaSplitter.SplitReflexive)reflex.Chunks[refcount], node);

                    refcount++;
          
                    
                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk )
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            FindSelectedNode((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount], node);
                            refcount++;
                            break;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
                //    refcount++;
                }
               
            }
        }






        public MetaSplitter.SplitReflexive FindSelectedNodeAndOverWrite(MetaSplitter.SplitReflexive reflex, TreeNode tn)
        {
            if (reflex.ChunkResources.Count == 0 && reflex.Chunks.Count == 0) { return reflex ; }
            int refcount = 0;
            foreach (TreeNode node in tn.Nodes)
            {
                if (node == treeView1.SelectedNode)
                {
                    if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                    {
                        if (ChunkAdder.ChunkClipBoard.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                        {
                            reflex.Chunks[refcount] = ChunkAdder.ChunkClipBoard;
                        }
                        else
                        {
                            MessageBox.Show("Overwrite chunks with chunks");
                        }
                      
                       return reflex;
                    }
                    else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                    {
                        do
                        {
                            if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                            {
                                if (ChunkAdder.ChunkClipBoard.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                                {
                                    reflex.ChunkResources[refcount] = ChunkAdder.ChunkClipBoard;
                                }
                                else
                                {
                                    MessageBox.Show("Overwrite reflexives with reflexives");
                                }
                            
                              return reflex;
                            }
                            refcount++;
                        }
                        while (refcount != -1);

                    }
                }

                if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    reflex.Chunks[refcount] = FindSelectedNodeAndOverWrite(reflex.Chunks[refcount], node);

                    refcount++;


                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            reflex.ChunkResources[refcount]=FindSelectedNodeAndOverWrite((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount], node);
                            refcount++;
                            break;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
                    //    refcount++;
                }

            }
            return reflex;
        }





        public MetaSplitter.SplitReflexive FindSelectedNodeAndAdd(MetaSplitter.SplitReflexive reflex, TreeNode tn)
        {
            if (reflex.ChunkResources.Count == 0 && reflex.Chunks.Count == 0) { return reflex; }
            int refcount = 0;
            foreach (TreeNode node in tn.Nodes)
            {
                if (node == treeView1.SelectedNode)
                {
                    if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                    {
                        if (ChunkAdder.ChunkClipBoard.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                        {
                            MetaSplitter.SplitReflexive split;
                            split=reflex.Chunks[refcount];
                            for (int x = 0; x < split.ChunkResources.Count; x++)
                            {
                                if (split.ChunkResources[x].type == Meta.ItemType.Reflexive)
                                {
                                    MetaSplitter.SplitReflexive tempref;
                                    tempref = split.ChunkResources[x] as MetaSplitter.SplitReflexive;
                                    if (tempref.description == ChunkAdder.ChunkClipBoard.description && tempref.chunksize == ChunkAdder.ChunkClipBoard.chunksize)
                                    {
                                        
                                    
                                        tempref.Chunks.AddRange(ChunkAdder.ChunkClipBoard.Chunks);
                                        //}
                                        split.ChunkResources[x] = tempref;
                                       reflex.Chunks[refcount] = split;
                                        return reflex; 
                                    }
                                }
                                           

                            }
                      
                            if (reflex!=ChunkAdder.ChunkClipBoard)
                            {
                                if (reflex.offset <= reflex.Chunks[refcount].chunksize - 8)
                                {
                                    int lowindex = -1;
                                    int lowoffset = 0;
                 
                                    int highoffset = reflex.Chunks[refcount].chunksize;
                                    for (int e=0;e<reflex.Chunks[refcount].ChunkResources.Count;e++)
                                    {
                                        Meta.Item mi=(Meta.Item)reflex.Chunks[refcount].ChunkResources[e];
                                    
                                        if (mi.offset<ChunkAdder.ChunkClipBoard.offset&&mi.offset>lowoffset)
                                        {
                                            lowindex = e;
                                            lowoffset = mi.offset;
                                        }
                                    }
                                    if (lowindex == -1)
                                    {
                                        reflex.Chunks[refcount].ChunkResources.Insert(0, ChunkAdder.ChunkClipBoard);
                                    }
                                    else
                                    {
                                        reflex.Chunks[refcount].ChunkResources.Insert(lowindex+1, ChunkAdder.ChunkClipBoard);
                                    }
                                }
                                else
                                {
                                    MessageBox.Show("The offset of the reflexive you are trying to paste is too high for this chunk size");
                                }
                            }
                            else
                            {
                                MessageBox.Show("You can not add a reflexive inside of itself");
                            }
                        }
                        else
                        {
                            reflex.Chunks.Insert(refcount+1,ChunkAdder.ChunkClipBoard);
                            //MessageBox.Show("Add chunks to reflexives not other chunks");
                        }
                        return reflex;


                        //reflex.chunkcount += ChunkAdder.ChunkClipBoard.Chunks.Count;
       

                    }
                    else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                    {

                        do
                        {
                            if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                            {
                             //   ((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount]).Chunks.Add(ChunkAdder.ChunkClipBoard);
                                if (ChunkAdder.ChunkClipBoard.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                                {
                                   ((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount]).Chunks.Add(ChunkAdder.ChunkClipBoard);
                                }
                                else
                                {

                                    MessageBox.Show("Add reflexives to chunks not other reflexives");
                                }
                                //  reflex.chunkcount += ChunkAdder.ChunkClipBoard.ChunkResources.Count;
                                return reflex;
                            }
                            refcount++;
                        }
                        while (refcount != -1);

                      
                    }
                }

                if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    reflex.Chunks[refcount] = FindSelectedNodeAndAdd(reflex.Chunks[refcount], node);

                    refcount++;


                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            reflex.ChunkResources[refcount] = FindSelectedNodeAndAdd((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount], node);
                            refcount++;
                            break;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
                    //    refcount++;
                }

            }
            return reflex;
        }





        public MetaSplitter.SplitReflexive FindSelectedNodeAndClone(MetaSplitter.SplitReflexive reflex, TreeNode tn)
        {
            if (reflex.ChunkResources.Count == 0 && reflex.Chunks.Count == 0) { return reflex; }
            int refcount = 0;
            foreach (TreeNode node in tn.Nodes)
            {
                if (node == treeView1.SelectedNode)
                {
                    if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                    {
                  
                            int fff=Convert.ToInt32(chunkamount.Text);
                            for (int x = 0; x < fff; x++)
                            {
                                reflex.Chunks.Insert(refcount+1,reflex.Chunks[refcount]);
                            }
                           
                      
                        return reflex;


                        //reflex.chunkcount += ChunkAdder.ChunkClipBoard.Chunks.Count;


                    }
                    else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                    {
                        MessageBox.Show("Only Clone Chunks");
                        return reflex;
                    }
                }

                if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    reflex.Chunks[refcount] = FindSelectedNodeAndClone(reflex.Chunks[refcount], node);

                    refcount++;


                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            reflex.ChunkResources[refcount] = FindSelectedNodeAndClone((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount], node);
                            refcount++;
                            break;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
                    //    refcount++;
                }

            }
            return reflex;
        }








        public MetaSplitter.SplitReflexive FindSelectedNodeAndDelete(MetaSplitter.SplitReflexive reflex, TreeNode tn)
        {
            if (reflex.ChunkResources.Count == 0 && reflex.Chunks.Count == 0) { return reflex; }
            int refcount = 0;
            foreach (TreeNode node in tn.Nodes)
            {
                if (node == treeView1.SelectedNode)
                {
                    if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                    {
                        reflex.Chunks.RemoveAt(refcount);
                        return reflex;


                        //reflex.chunkcount += ChunkAdder.ChunkClipBoard.Chunks.Count;


                    }
                    else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                    {

                        do
                        {
                            if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                            {

                                reflex.ChunkResources.RemoveAt(refcount);
                                return reflex;
                        
                            }
                            refcount++;
                        }
                        while (refcount != -1);

                      
                    }
                }

                if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Container)
                {
                    reflex.Chunks[refcount] = FindSelectedNodeAndDelete(reflex.Chunks[refcount], node);

                    refcount++;


                }
                else if (reflex.splitReflexiveType == MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk)
                {
                    do
                    {
                        if (reflex.ChunkResources[refcount].type == Meta.ItemType.Reflexive)
                        {

                            reflex.ChunkResources[refcount] = FindSelectedNodeAndDelete((MetaSplitter.SplitReflexive)reflex.ChunkResources[refcount], node);
                            refcount++;
                            break;
                        }
                        refcount++;
                    }
                    while (refcount != -1);
                    //    refcount++;
                }

            }
            return reflex;
        }







        private static string GetBaseTypeString(string name)
        {
            string[] split = name.Split('-');
            string tempstring = split[0].Trim();
            return tempstring;
        }
      

        private void SplitIFP()
        {
            Meta m = new Meta();
            m.ReadMetaFromMap(TagNumber, mapnumber, false);
            IFPIO ifpx = IFP.IFPHashMap.GetIfp(m.type, mapnumber);
            m.headersize = ifpx.headerSize;
            MetaScanner metaScanner = new MetaScanner();
            metaScanner.ScanWithIFP(ref ifpx, ref m, mapnumber);
            metasplit = new MetaSplitter();
            metasplit.SplitWithIFP(ref ifpx, ref m, mapnumber);
      
        }

        private void DisplaySplit(MetaSplitter.SplitReflexive reflex,TreeNode tn)
        {

            
            for (int x = 0; x < reflex.Chunks.Count; x++)
            {
                string tempchunk=reflex.description;
                
                foreach (Meta.Item mi in reflex.Chunks[x].ChunkResources)
                {
                    if (mi.description == reflex.label)
                    {
                        tempchunk = ((Meta.String)mi).name;
                        break;
                    }
                    if (mi.type == Meta.ItemType.String)
                    {

                        tempchunk = ((Meta.String)mi).name;
                    }
                    if (mi.type == Meta.ItemType.Ident)
                    {
                        tempchunk = ((Meta.Ident)mi).pointstotagname;
                        string[] splits = tempchunk.Split('\\');
                        tempchunk = splits[splits.Length - 1] + "." + ((Meta.Ident)mi).pointstotagtype;
                        break;
                    }
                }
                string tempchunkname = "Chunk - Number: " + x.ToString()
                    + " - Name: " + tempchunk
                    + " - Size: " + reflex.Chunks[x].chunksize.ToString();
                    
                TreeNode ChunkNumberNode = new TreeNode(tempchunkname);
                MetaSplitter.SplitReflexive split=(MetaSplitter.SplitReflexive)  reflex.Chunks[x];
                for (int y = 0; y < split.ChunkResources.Count; y++)
                {
                    if (split.ChunkResources[y].type == Meta.ItemType.Reflexive)
                    {
                        TreeNode reflexnode = new TreeNode("Reflexive - Name: " + split.ChunkResources[y].description + " - Size: " + ((MetaSplitter.SplitReflexive)split.ChunkResources[y]).chunksize + " - Offset: " + split.ChunkResources[y].offset.ToString());
                        DisplaySplit((MetaSplitter.SplitReflexive)split.ChunkResources[y],reflexnode);
                        ChunkNumberNode.Nodes.Add(reflexnode);
                    }
                }
                tn.Nodes.Add(ChunkNumberNode);
            }
        }
        #region ChunkFunctions
        #region Copy
        private void copybutton_Click(object sender, EventArgs e)
        {
            FindSelectedNode(metasplit.Header, treeView1.Nodes[0]);
        }
        #endregion
        #region OverWrite
        private void addchunks_Click(object sender, EventArgs e)
        {

            FindSelectedNodeAndOverWrite(metasplit.Header, treeView1.Nodes[0]);
            treeView1.Nodes[0].Nodes.Clear();
            DisplaySplit(metasplit.Header, treeView1.Nodes[0]);
           // treeView1.ExpandAll();
        }
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

           ChunkAdder.Add(mapnumber, TagNumber,metasplit);
           result = true;
           this.Close();
        }
        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            FindSelectedNodeAndAdd(metasplit.Header, treeView1.Nodes[0]);
            treeView1.Nodes[0].Nodes.Clear();
            DisplaySplit(metasplit.Header, treeView1.Nodes[0]);
           // treeView1.ExpandAll();
           
        }

        private void button3_Click(object sender, EventArgs e)
        {
            FindSelectedNodeAndClone(metasplit.Header, treeView1.Nodes[0]);
            treeView1.Nodes[0].Nodes.Clear();
            DisplaySplit(metasplit.Header, treeView1.Nodes[0]);
           // treeView1.ExpandAll();
        
        }

        private void button4_Click(object sender, EventArgs e)
        {
            FindSelectedNodeAndDelete(metasplit.Header, treeView1.Nodes[0]);
            treeView1.Nodes[0].Nodes.Clear();
            DisplaySplit(metasplit.Header, treeView1.Nodes[0]);
           // treeView1.ExpandAll();
        }

        private void savemeta_Click(object sender, EventArgs e)
        {
    
           
            Meta tempm = MetaBuilder.BuildMeta(metasplit, mapnumber);//(Meta) metas[tagnumber];

            tempm.RelinkReferences(mapnumber);
            SaveFileDialog save = new SaveFileDialog();
            string[] split = metasplit.name.Split('\\');
            string temp = split[split.Length - 1] + "." + metasplit.type;
            temp = temp.Replace('<', '_');
            temp = temp.Replace('>', '_');
            save.FileName = temp;
            if (save.ShowDialog() == DialogResult.Cancel) { return; }
            tempm.SaveMetaToFile(save.FileName);
            MessageBox.Show("Done");
        }

        private void collapse_Click(object sender, EventArgs e)
        {
            treeView1.CollapseAll();
            treeView1.Nodes[0].Expand();
            treeView1.Nodes[0].Nodes[0].Expand();
        }

        private void expand_Click(object sender, EventArgs e)
        {
            treeView1.Nodes[0].ExpandAll();
        }
    }
}