using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Management;

namespace entity.Forms
{
    public partial class BetaLogin : Form
    {
        private Label label3;
        private Label label2;
        private Label label1;
        private TextBox textBox2;
        private TextBox textBox1;
        private Button button1;

        public BetaLogin()
        {
            InitializeComponent();
        }

        public System.IO.StreamReader LoginSite(string username, string pass)
        {

            string text1 = "http://haloplugins.com/betalogin.php";
            System.Net.HttpWebRequest request1 = ((System.Net.HttpWebRequest)(System.Net.WebRequest.Create(text1)));
            request1.Method = "POST";
            request1.ContentType = "application/x-www-form-urlencoded";
            string[] textArray3 = new string[] { "username=" + username + "&password=" + pass + "&macaddress=" + FillNetworkAdapters() };
            string text2 = string.Concat(textArray3);
            System.Text.ASCIIEncoding encoding1 = new System.Text.ASCIIEncoding();
            byte[] buffer1 = encoding1.GetBytes(text2);
            System.IO.Stream stream1 = request1.GetRequestStream();
            stream1.Write(buffer1, 0, buffer1.Length);
            stream1.Close();
            System.Net.HttpWebResponse response1 = ((System.Net.HttpWebResponse)(request1.GetResponse()));
            System.IO.StreamReader reader1 = new System.IO.StreamReader(response1.GetResponseStream());
            return reader1;
        }

        private string FillNetworkAdapters()
        {
            string returnstring = "";
            ManagementObjectCollection collection1 = new ManagementClass("Win32_NetworkAdapterConfiguration").GetInstances();
            foreach (ManagementObject obj1 in collection1)
            {
                if ((bool)obj1["IPEnabled"])
                {
                    string text1 = obj1["Caption"].ToString().Substring(11);
                    returnstring = GetMACAddress(text1);
                    break;
                }
            }
            return returnstring;
        }

        private string GetMACAddress(string Adapter)
        {
            string text1 = "";
            ManagementObjectCollection collection1 = new ManagementClass("Win32_NetworkAdapterConfiguration").GetInstances();
            foreach (ManagementObject obj1 in collection1)
            {
                if ((bool)obj1["IPEnabled"])
                {
                    string text2 = obj1["Caption"].ToString().Substring(11);
                    if (text2 == Adapter)
                    {
                        text1 = obj1["MacAddress"].ToString();
                    }
                }
            }
            return text1;
        }

        private void InitializeComponent()
        {
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(26, 20);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(279, 15);
            this.label3.TabIndex = 11;
            this.label3.Text = "Please login with your entity beta user information.";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(58, 84);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(73, 17);
            this.label2.TabIndex = 10;
            this.label2.Text = "Password:";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(58, 58);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(77, 17);
            this.label1.TabIndex = 9;
            this.label1.Text = "Username:";
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(136, 83);
            this.textBox2.Name = "textBox2";
            this.textBox2.PasswordChar = '*';
            this.textBox2.Size = new System.Drawing.Size(136, 20);
            this.textBox2.TabIndex = 8;
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(136, 57);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(136, 20);
            this.textBox1.TabIndex = 7;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(109, 123);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(113, 23);
            this.button1.TabIndex = 6;
            this.button1.Text = "Login";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click_1);
            // 
            // BetaLogin
            // 
            this.BackColor = System.Drawing.Color.SteelBlue;
            this.ClientSize = new System.Drawing.Size(331, 164);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.button1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.Name = "BetaLogin";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.TopMost = true;
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        private void button1_Click_1(object sender, EventArgs e)
        {

            string specialstring = LoginSite(textBox1.Text.ToString(), textBox2.Text.ToString()).ReadToEnd().ToString();
            if (specialstring == "0")
            {
                MessageBox.Show("Sorry but you could not be logged in.");
                Application.Exit();
            }
            else if (specialstring == "1")
            {
                MessageBox.Show("You are now logged in.");
                this.Close();

            }
            else
            {
                MessageBox.Show("Sorry but there was a problem with the login system.");
                //MessageBox.Show(specialstring);
                Application.Exit();
            }

        }

    }
}