using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace entity.Forms.HexEditor
{
    public partial class GoToDialogBox : Form
    {
        int offset=0;
        public int Offset
        {
            get
            {
                return offset;
            }
            
        }

        public GoToDialogBox()
        {
            InitializeComponent();
            maskedTextBox1.Text = Offset.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (decimalbutton.Checked == true)
                {
                    this.offset = int.Parse(maskedTextBox1.Text);
                }
                else
                {
                    this.offset = int.Parse(maskedTextBox1.Text, System.Globalization.NumberStyles.HexNumber);
                }
                this.offset = this.offset / 10 *10;
                DialogResult = DialogResult.OK;
            }
            catch
            {
                MessageBox.Show("Invalid Entry");
                return;
            }

            this.Hide();
        }

        private void decimalbutton_CheckedChanged(object sender, EventArgs e)
        {
            decimalbutton.Checked = true;
            hexadecimalbutton.Checked = false;
            try
            {
                maskedTextBox1.Text = int.Parse(maskedTextBox1.Text,System.Globalization.NumberStyles.HexNumber).ToString();
            }
            catch
            {
            }
        }

        private void hexadecimalbutton_CheckedChanged(object sender, EventArgs e)
        {
            decimalbutton.Checked = false;
            hexadecimalbutton.Checked = true;
            try
            {
                maskedTextBox1.Text = int.Parse(maskedTextBox1.Text).ToString("X");
                
            }
            catch
            {
            }
        }
    }
}