using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace entity.Forms
{
    public partial class SkinOptions : Form
    {
        public SkinOptions()
        {
            InitializeComponent();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                comboBox1.Enabled = true;
            }
            else
            {
                comboBox1.Enabled = false;
            }
        }
        public SkinInfo[] skinshit;
        public void GenerateSkinSets()
        {

            skinshit = new SkinInfo[100];

              System.IO.DirectoryInfo di = new System.IO.DirectoryInfo(Application.StartupPath + "\\Skins");
              System.IO.FileInfo[] diar1 = di.GetFiles("*.esf");
            int i = 0;  
            foreach (System.IO.FileInfo dra in diar1)
            {
                    skinshit[i] = teststuff(dra.ToString());
                    i = i + 1;  
   
            }

            for (int j = 0; j < i; j++)
            {

                comboBox1.Items.Add(skinshit[j].skin_name.ToString());
              
            }


        }

        public SkinInfo teststuff(string filepath)
        {

            SkinInfo si;

            System.IO.StreamReader sr = new System.IO.StreamReader(Application.StartupPath + "\\Skins\\" + filepath);
            si.skin_Path = filepath;
            System.Xml.XmlTextReader xr = new System.Xml.XmlTextReader(sr);
            System.Xml.XmlDocument settingsxml = new System.Xml.XmlDocument();
            settingsxml.Load(xr);
            System.Xml.XmlNodeList FormSettingsXmlNode = settingsxml.SelectNodes("skin/settings");
            //Name
            System.Xml.XmlNode SkinInfo = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Name");
            si.skin_name = SkinInfo.InnerText.ToString();
            //Author
            SkinInfo = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Author");
            si.skin_Author = SkinInfo.InnerText.ToString();
            //Version
            SkinInfo = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Version");
            si.skin_Version = SkinInfo.InnerText.ToString();
            sr.Close();

            return si;

        }

        public SkinINFO2User ReadSkinInfo()
        {

            SkinINFO2User si;

            System.IO.StreamReader sr = new System.IO.StreamReader(Application.StartupPath + "\\Skins\\Settings.xml");
            System.Xml.XmlTextReader xr = new System.Xml.XmlTextReader(sr);
            System.Xml.XmlDocument settingsxml = new System.Xml.XmlDocument();
            settingsxml.Load(xr);
            System.Xml.XmlNodeList FormSettingsXmlNode = settingsxml.SelectNodes("skin/settings");
            //Use Skin
            System.Xml.XmlNode SkinInfo = FormSettingsXmlNode.Item(0).SelectSingleNode("Use_Skin");
            si.Use_Skin = SkinInfo.InnerText.ToString();
            //Skin Path
            SkinInfo = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Path");
            si.Skin_Path = SkinInfo.InnerText.ToString();
            sr.Close();

            return si;

        }

        public struct SkinInfo
        {
           public string skin_name;
           public string skin_Author;
           public string skin_Version;
           public string skin_Path;
        }

        public struct SkinINFO2User
        {
            public string Use_Skin;
            public string Skin_Path;
        }

        private void SkinOptions_Load(object sender, EventArgs e)
        {
            GenerateSkinSets();
            GetSettings();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int index = -1;
            for(int i = 0; i < skinshit.Length; i++)
            {
                if (skinshit[i].skin_name == comboBox1.Text)
                {
                    index = i;
                    break;
                }
            }
            if (index != -1)
            {
                label4.Text = skinshit[index].skin_name;
                label5.Text = skinshit[index].skin_Author;
                label6.Text = skinshit[index].skin_Version;             
            }

        }


        public void GetSettings()
        {

            if (ReadSkinInfo().Use_Skin != "true")
            {
                comboBox1.Enabled = false;
                checkBox1.Checked = false;
            }
            else
            {
                comboBox1.Enabled = true;
                checkBox1.Checked = true;
                int index = -1;
                for (int i = 0; i < skinshit.Length; i++)
                {
                    if (skinshit[i].skin_Path == ReadSkinInfo().Skin_Path)
                    {
                        index = i;
                        break;
                    }
                }

                comboBox1.SelectedIndex = index;
                
            }

        }

        public Form1 mainform;

        private void button1_Click(object sender, EventArgs e)
        {

            string path = Application.StartupPath + "\\skins\\Settings.xml";
            System.IO.TextWriter tw;
            tw = new StreamWriter(path,false);
            tw.WriteLine("<skin>");
            tw.WriteLine("  <settings>");
            if (checkBox1.Checked != false)
            {
                int index = -1;
                for (int i = 0; i < skinshit.Length; i++)
                {
                    if (skinshit[i].skin_name == comboBox1.Text)
                    {
                        index = i;
                        break;
                    }
                }
                if (index != -1)
                {
                    tw.WriteLine("    <Use_Skin>true</Use_Skin>");
                    tw.WriteLine("    <Skin_Path>" + skinshit[index].skin_Path + "</Skin_Path>");
                }
            }
            else
            {
                tw.WriteLine("    <Use_Skin>false</Use_Skin>");
                tw.WriteLine("    <Skin_Path>Default</Skin_Path>");

            }

            tw.WriteLine("  </settings>");
            tw.WriteLine("</skin>");

            tw.Close();

            mainform.ReloadSkins();

            MessageBox.Show("Saved!");
            this.Close();

        }
        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}