using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Windows.Forms;
using System.Drawing;

namespace entity.Forms
{
    public partial class VideoSettings : Form
    {
        public VideoSettings()
        {
            InitializeComponent();
            
           
    
            Caps hardware = Manager.GetDeviceCaps(0, DeviceType.Hardware);
            Label l1 = new Label();
            l1.Dock = DockStyle.Top;
            l1.Text = "Number of Textures: " + hardware.MaxSimultaneousTextures.ToString();
            this.Controls.Add(l1);
            Label l2 = new Label();
            l2.Dock = DockStyle.Top;
            l2.Text = "Supports Mip Map: " + hardware.TextureCaps.SupportsMipMap.ToString();
            this.Controls.Add(l2);
            Label l3 = new Label();
            l3.Dock = DockStyle.Top;
            l3.Text = "Supports SupportsBumpEnvironmentMap: " + hardware.TextureOperationCaps.SupportsBumpEnvironmentMap.ToString();
            this.Controls.Add(l3);
            Label l4 = new Label();
            l4.Dock = DockStyle.Top;
            l4.Text = "Supports Modulate2X: " + hardware.TextureOperationCaps.SupportsModulate2X;
            this.Controls.Add(l4);
            Label l5 = new Label();
            l5.Dock = DockStyle.Top;
            l5.Text = "Supports Modulate: " + hardware.TextureOperationCaps.SupportsModulate;
            this.Controls.Add(l5);
            Label l6 = new Label();
            l6.Dock = DockStyle.Top;
            l6.Text = "Supports SupportsHardwareTransformAndLight: " + hardware.DeviceCaps.SupportsHardwareTransformAndLight.ToString();
            this.Controls.Add(l6);
            Label l7 = new Label();
            l7.Dock = DockStyle.Top;
            l7.Text = "Supports MaxActiveLights: " + hardware.MaxActiveLights.ToString();
            this.Controls.Add(l7);
            Label l8 = new Label();
            l8.Dock = DockStyle.Top;
            l8.Text = "SupportsInverseSourceAlpha: " + hardware.SourceBlendCaps.SupportsInverseSourceAlpha.ToString();
            this.Controls.Add(l8);
            Label l9 = new Label();
            l9.Dock = DockStyle.Top;
            l9.Text = "SupportsSourceAlpha: " + hardware.SourceBlendCaps.SupportsSourceAlpha.ToString();
            this.Controls.Add(l9);
            Label l10 = new Label();
            l10.Dock = DockStyle.Top;
            l10.Text = "SupportsMagnifyLinear: " + hardware.TextureFilterCaps.SupportsMagnifyLinear.ToString();
            this.Controls.Add(l10);
            Label l11 = new Label();
            l11.Dock = DockStyle.Top;
            l11.Text = "SupportsMinifyLinear: " + hardware.TextureFilterCaps.SupportsMinifyLinear.ToString();
            this.Controls.Add(l11);
            Label l12 = new Label();
            l12.Dock = DockStyle.Top;
            l12.Text = "SupportsMipMapLinear: " + hardware.TextureFilterCaps.SupportsMipMapLinear.ToString();
            this.Controls.Add(l12);
            Label l13 = new Label();
            l13.Dock = DockStyle.Top;
            l13.Text = "CanAutoGenerateMipMap: " + hardware.DriverCaps.CanAutoGenerateMipMap.ToString();
            this.Controls.Add(l13);

            Label l14 = new Label();
            l14.Dock = DockStyle.Top;
            l14.Text = "SupportsBlend: " + hardware.LineCaps.SupportsBlend.ToString();
            this.Controls.Add(l14);

            Label l15 = new Label();
            l15.Dock = DockStyle.Top;
            l15.Text = "SupportsFog: " + hardware.LineCaps.SupportsFog.ToString();
            this.Controls.Add(l15);

            Label l16 = new Label();
            l16.Dock = DockStyle.Top;
            l16.Text = "Supports No Culling: " + hardware.PrimitiveMiscCaps.SupportsCullNone.ToString();
            this.Controls.Add(l16);

            Label l17 = new Label();
            l17.Dock = DockStyle.Top;
            l17.Text = "Supports Texture State: " + hardware.PrimitiveMiscCaps.SupportsTextureStageStateArgumentTemp.ToString();
            this.Controls.Add(l17);

            Label l18 = new Label();
            l18.Dock = DockStyle.Top;
            l18.Text = "SupportsWrap: " + hardware.VolumeTextureAddressCaps.SupportsWrap.ToString();
            this.Controls.Add(l18);
        }
    }
}