using System;
using System.Collections;
namespace entity.MetaContainers
{
	/// <summary>
	/// Summary description for hlmt.
	/// </summary>
	public class hlmtContainer
	{
		public int tagnumber;
		public PermutationInfo[] Permutations;
        public hlmtContainer(int tagnumberx, int mapnumber)
		{
			Maps.map[mapnumber].OpenMap(MapTypes.Internal);
			tagnumber=tagnumberx;
			Maps.map[mapnumber].BR.BaseStream.Position=Maps.map[mapnumber].MetaInfo.Offset[tagnumber]+80;
			int tempc=Maps.map[mapnumber].BR.ReadInt32();
			int tempr=Maps.map[mapnumber].BR.ReadInt32()-Maps.map[mapnumber].SecondaryMagic;
			Permutations=new PermutationInfo[tempc];
			for (int x=0;x<tempc;x++)
			{
				Permutations[x]=new PermutationInfo();
				Maps.map[mapnumber].BR.BaseStream.Position=tempr+(x*56);
                Permutations[x].Name = Maps.map[mapnumber].Strings.Name[Maps.map[mapnumber].BR.ReadInt16()];
				Maps.map[mapnumber].BR.BaseStream.Position=tempr+(x*56)+20;
				int tempc2=Maps.map[mapnumber].BR.ReadInt32();
				int tempr2=Maps.map[mapnumber].BR.ReadInt32()-Maps.map[mapnumber].SecondaryMagic;
				Permutations[x].Piece=new PermutationInfo.PermutationPiece[tempc2];  
				for (int xx=0;xx<tempc2;xx++)
				{
					Permutations[x].Piece[xx]=new PermutationInfo.PermutationPiece(); 
					Maps.map[mapnumber].BR.BaseStream.Position=tempr2+(xx*20);
					string temps=Maps.map[mapnumber].Strings.Name[Maps.map[mapnumber].BR.ReadInt16()];
					Permutations[x].Piece[xx].PieceName=temps;
					Maps.map[mapnumber].BR.BaseStream.Position=tempr2+(xx*20)+8;
					int tempc3=Maps.map[mapnumber].BR.ReadInt32();
					int tempr3=Maps.map[mapnumber].BR.ReadInt32()-Maps.map[mapnumber].SecondaryMagic;
					Permutations[x].Piece[xx].Permutation=new PermutationInfo.PermutationPiece.PermutationVariation[tempc3]; 
					for (int xxx=0;xxx<tempc3;xxx++)
					{
                        Permutations[x].Piece[xx].Permutation[xxx] = new PermutationInfo.PermutationPiece.PermutationVariation();
						Maps.map[mapnumber].BR.BaseStream.Position=tempr3+(xxx*32);
						string temps2=Maps.map[mapnumber].Strings.Name[Maps.map[mapnumber].BR.ReadInt16()];
						Permutations[x].Piece[xx].Permutation[xxx].PermutationNameX=temps2;
						Maps.map[mapnumber].BR.BaseStream.Position=tempr3+(xxx*32)+12;
						int tempc4=Maps.map[mapnumber].BR.ReadInt32();
						int tempr4=Maps.map[mapnumber].BR.ReadInt32()-Maps.map[mapnumber].SecondaryMagic;
						//Permutations[x].Piece[xx].Permutation=new PermutationInfo.PermutationPiece.PermutationVariation[tempc4]; 
						for (int xxxx=0;xxxx<tempc4;xxxx++)
						{
							//Permutations[x].Piece[xx].Permutation[xxxx]=new entity.MetaContainers.hlmtContainer.PermutationInfo.PermutationPiece.PermutationVariation();
						//	Maps.map[mapnumber].BR.BaseStream.Position=tempr4+(xxxx*24);
						//	string temp3=Maps.map[mapnumber].Strings.Name[Maps.map[mapnumber].BR.ReadInt16()];
							
							//PermutationPiece p=new PermutationPiece();
							
							//p.PermutationName=temps2;
							//p.PermutationNameX=temp3;
							//Permutations[x].Permutation.Add(p);
						}
					}
				}
			}
			Maps.map[mapnumber].CloseMap();
		}


        public int FindPermutationByBaseClass(int tagnumber, ref Map map)
        {
            if (tagnumber == -1) { return -1; }
            int tempoff = 0;
            switch (map.MetaInfo.TagType[tagnumber])
            {
                case "itmc":
                    
                case "vehc":
                    tempoff = 24;
                    break;
                case "vehi":
                
                case "bloc":
                case "bipd":
                case "mach":
                case "scen":
                case "eqip":
                case "weap":
                    tempoff = 48;
                    break;
                default:
                    return -1;
            }
            map.OpenMap(MapTypes.Internal);


            map.BR.BaseStream.Position = map.MetaInfo.Offset[tagnumber] + tempoff;
            string tempname=map.Strings.Name[map.BR.ReadInt16()];
         
            return FindPermutation(tempname);
        }


        public int FindPermutation(string permutationName)
        {
            for (int x = 0; x < this.Permutations.Length; x++)
            {
                if (this.Permutations[x].Name == permutationName)
                {
                    return x;
                }
            }
            return 0;
        }



		public class PermutationInfo
		{
			public string Name;
			public PermutationPiece[] Piece;
			public class PermutationPiece
			{
				public string PieceName;
				public PermutationVariation[] Permutation;
				public class PermutationVariation
				{
					public string PermutationNameX;
				}
				
			}
		}
	}
}
