using System;
using System.Collections.Generic;
using System.Text;

namespace entity.H2MetaContainers
{

        public class H2SBSP : TagInterface
        {


            public H2SBSP(int tagnumber, int mapnumber)
                : base(tagnumber, mapnumber)
            {


            }
            public class SBSP : TagBlockLayout
            {


                public SBSP()
                    { }

                public class BSP : TagBlockLayout
                {


                    public BSP()
                       
                    {

                    }


                    public class BSP3DNode : TagBlockLayout
                    {
                        ShortInteger plane_index = new ShortInteger("BSP_Plane Index");
                        ShortInteger backchild = new ShortInteger("Back Child");
                        ByteInteger unknown1 = new ByteInteger("Unknown 1");
                        ShortInteger frontchild = new ShortInteger("Front Child");
                        ByteInteger unknown2 = new ByteInteger("Unknown 2");
                        public BSP3DNode()
                           
                        {
                            Add(plane_index);
                         
                            Add(backchild);
                            Add(unknown1);
                            Add(frontchild);
                            Add(unknown2);
                        }

                        public static readonly BSP3DNode Layout = new BSP3DNode();
                    }


                    public class BSP_Plane : TagBlockLayout
                    {
                        RealPlane3D plane = new RealPlane3D("BSP_Plane");

                        public BSP_Plane()
                           
                        {
                            Add(plane);
                        }

                        public static readonly BSP_Plane Layout = new BSP_Plane();
                    }


                    public class Leaf : TagBlockLayout
                    {
                        WordFlags flags = new WordFlags("Flags");
                        ByteInteger bsp2drefindex = new ByteInteger("BSP_2D_Reference Start Index");
                        ShortInteger bsp2drefcount = new ShortInteger("BSP_2D_Reference Count");
                        
                        public Leaf()
                           
                        {
                            Add(flags);
                            Add(bsp2drefindex);
                            Add(bsp2drefcount);
                       
                        }

                        public static readonly Leaf Layout = new Leaf();
                    }



                    public class BSP_2D_Reference : TagBlockLayout
                    {
                        ShortInteger plane_index = new ShortInteger("BSP_Plane Index");
                        ShortInteger bsp_2d_node_index = new ShortInteger("BSP_2D_Node Index");
                        public BSP_2D_Reference()
                        
                        {
                            Add(plane_index);
                            Add(bsp_2d_node_index);
                        }

                        public static readonly BSP_2D_Reference Layout = new BSP_2D_Reference();
                    }

                    public class BSP_2D_Node : TagBlockLayout
                    {
                        RealPlane3D plane = new RealPlane3D("Plane");
                        ShortInteger leftchild = new ShortInteger("Left Child");
                        ShortInteger rightchild = new ShortInteger("Right Child");
                        public BSP_2D_Node()
                           
                        {
                            Add(plane);
                            Add(leftchild);
                            Add(rightchild);
                        }

                        public static readonly BSP_2D_Node Layout = new BSP_2D_Node();
                    }

                    public class BSP_Surface : TagBlockLayout
                    {
                        ShortInteger plane_index = new ShortInteger("Plane Index");
                        ShortInteger first_edge = new ShortInteger("First Edge");
                        ByteFlags flags = new ByteFlags("Flags");
                        ByteInteger breakablesurface_index = new ByteInteger("Breakable Surface Index");
                        ShortInteger collision_material_index = new ShortInteger("Collision Material Index");

                        public BSP_Surface()
                           
                        {
                            Add(plane_index);
                            Add(first_edge);
                            Add(flags);
                            Add(breakablesurface_index);
                            Add(collision_material_index);
                        }

                        public static readonly BSP_Surface Layout = new BSP_Surface();
                    }



                    public class Edge : TagBlockLayout
                    {
                        ShortInteger StartVertex = new ShortInteger("Start Vertex");
                        ShortInteger EndVertex = new ShortInteger("End Vertex");
                        ShortInteger ForwardEdge = new ShortInteger("Forward Edge");
                        ShortInteger ReverseEdge = new ShortInteger("Reverse Edge");
                        ShortInteger LeftSurface = new ShortInteger("Left Surface");
                        ShortInteger RightSurface = new ShortInteger("Right Surface");
                        public Edge()
                           
                        {
                            Add(StartVertex);
                            Add(EndVertex);
                            Add(ForwardEdge);
                            Add(ReverseEdge);
                            Add(LeftSurface);
                            Add(RightSurface);
                        }

                        public static readonly Edge Layout = new Edge();
                    }

                    public class Vertice : TagBlockLayout
                    {
                        RealPoint3D vertice = new RealPoint3D("Vertice");
                        LongInteger firstedge = new LongInteger("First Edge");
                        public Vertice()
                           
                        {
                            Add(vertice);
                            Add(firstedge);
                        }
                        public static readonly Vertice Layout = new Vertice();

                    }
                }


            }



        }
    
}
