using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace entity
{
    public sealed class ChunkAdder
    {
        #region Fields

        public static int SizeOfShift;
        public static int OffsetOfShift;
        public static int TagNumber;
        public static MetaSplitter.SplitReflexive ChunkClipBoard;
        #endregion
        #region Methods
        public static void Add(int mapnumber,int tagnumber, MetaSplitter metasplit)
        {
     
     
            TagNumber = tagnumber;

            #region LoadMetas
            ArrayList metas=new ArrayList(0);
            for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
            {
                Meta m = new Meta();
                m.ReadMetaFromMap(x, mapnumber, true);


                IFPIO ifpx = IFP.IFPHashMap.GetIfp(m.type,mapnumber);
                m.headersize = ifpx.headerSize;

                MetaScanner metaScanner = new MetaScanner();
                if (m.type == "sbsp")
                {
                   //
                }
                else
                {
                    metaScanner.ScanWithIFP(ref ifpx, ref m, mapnumber);
                   // metaScanner.ScanManually(ref m, ref map);
                }
                metas.Add(m);
            }
            #endregion

            Meta passme = (Meta)metas[tagnumber];
     
            Meta tempm = MetaBuilder.BuildMeta(metasplit, mapnumber);//(Meta) metas[tagnumber];
           metas[tagnumber] = tempm;
         //   ((Meta)metas[tagnumber]).RelinkReferences(mapnumber);
            int diff =  tempm.size - passme.size;
            SizeOfShift=diff;
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            FixReflexives(metas, mapnumber);

           
            Maps.map[mapnumber].CloseMap();
        }

        public static void Add(int mapnumber, Meta meta)
        {
     
         
            TagNumber = meta.tagnumber;

            #region LoadMetas
            ArrayList metas = new ArrayList(0);
            for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
            {
                if (TagNumber == x)
                {
                    metas.Add(meta);
                    continue;
                }
                Meta m = new Meta();
                m.ReadMetaFromMap(x, mapnumber, true);


                IFPIO ifpx = IFP.IFPHashMap.GetIfp(m.type,mapnumber);
                m.headersize = ifpx.headerSize;

                MetaScanner metaScanner = new MetaScanner();

                if (m.type == "sbsp")
                {
                }
                else
                {
                    metaScanner.ScanWithIFP(ref ifpx, ref m, mapnumber);
                }
                    // metaScanner.ScanManually(ref m, ref map);
              
                metas.Add(m);
            }
            #endregion
        
            int diff = meta.size - Maps.map[mapnumber].MetaInfo.Size[TagNumber];
            SizeOfShift = diff;
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            FixReflexives(metas, mapnumber);
            Maps.map[mapnumber].CloseMap();

         
        }
 
    
      
        public static void FixReflexives(ArrayList metas, int mapnumber)
        {
            int where = Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart;

            int howfar = 0;
            int[] oldoffset = (int[])Maps.map[mapnumber].MetaInfo.Offset.Clone();
            int padding = 0;
            for (int x = 0; x < metas.Count; x++)
            {
                Meta m = (Meta)metas[x];
                int fuck = Maps.map[mapnumber].IndexHeader.tagsOffset + (x * 16);
                int offset = oldoffset[x]+padding;
                if (x > ChunkAdder.TagNumber) { offset += ChunkAdder.SizeOfShift; }
                int offsetwithmagic = offset + Maps.map[mapnumber].SecondaryMagic;
                int size = m.size;
                if (m.type == "phmo" | m.type == "coll" | m.type == "spas")
                {
                    int tempoffset = offset;
                    do
                    {
                        string tempss = tempoffset.ToString("X");
                        char[] tempc = tempss.ToCharArray();
                        int xxx = tempc.Length;
                        if (m.padding == tempc[xxx - 1])
                        {
                            int diff = tempoffset - offset;
                            byte[] tempb = new byte[diff];
                            Maps.map[mapnumber].BW.BaseStream.Position = offset;
                            Maps.map[mapnumber].BW.Write(tempb);
           
                                int tempsize = ((Meta)metas[x - 1]).size;
                                tempsize += diff;
                                int temploc = Maps.map[mapnumber].IndexHeader.tagsOffset + ((x - 1) * 16) + 12;
                                Maps.map[mapnumber].BW.BaseStream.Position = temploc;
                                Maps.map[mapnumber].BW.Write(tempsize);

                     
                            offset = tempoffset;
                            howfar += diff;
                            padding += diff;
                            break;
                        }
                        tempoffset++;
                    }
                    while (fuck != -54454);
                }
          

               
                if (m.type!="sbsp"&&m.type!="ltmp")
                {
                   
                }
                else
                {
                    continue;
                }
                howfar += size;


             
        
                Maps.map[mapnumber].MetaInfo.Offset[x] = offset;
      
                offsetwithmagic = Maps.map[mapnumber].MetaInfo.Offset[x] + Maps.map[mapnumber].SecondaryMagic;
                Maps.map[mapnumber].BW.BaseStream.Position = fuck + 8;
                Maps.map[mapnumber].BW.Write(offsetwithmagic);
                Maps.map[mapnumber].BW.Write(size);
               
         
           
                
            }

            for (int x = 0; x < metas.Count; x++)
            {
                Meta m = (Meta)metas[x];
                if (m.type == "sbsp" || m.type == "ltmp") { continue; }
                m.offset = Maps.map[mapnumber].MetaInfo.Offset[x];
                m.WriteReferences();
                Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[x];
                Maps.map[mapnumber].BW.BaseStream.Write(m.MS.ToArray(), 0, m.size);
            }
            int prevsize = Maps.map[mapnumber].MapHeader.fileSize - (Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart);
            int paddingx=Maps.map[mapnumber].Functions.Padding(howfar,512);
            byte[] tempbb = new byte[paddingx];
            Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart + howfar;
            Maps.map[mapnumber].BW.Write(tempbb);
            howfar += paddingx;
           
            int sizediff = howfar - prevsize;
            int newfilesize = Maps.map[mapnumber].MapHeader.fileSize + sizediff;
            Maps.map[mapnumber].BW.BaseStream.Position = 8;
            Maps.map[mapnumber].BW.Write(newfilesize);
            int metasize = Maps.map[mapnumber].MapHeader.metaSize + sizediff;
            int combined = Maps.map[mapnumber].MapHeader.combinedSize + sizediff;
            Maps.map[mapnumber].BW.BaseStream.Position = 24;
            Maps.map[mapnumber].BW.Write(metasize);
            Maps.map[mapnumber].BW.Write(combined);
            Maps.map[mapnumber].FS.SetLength(newfilesize);
        
        }
        #endregion
        #region Classes
        public class ChunkContainer
        {
            public MemoryStream MS = new MemoryStream();
            public string parent;
            public int size;
            public int offset;
            public int mapoffset;
            public int translation;
            public List<Meta.Item> References;
            public List<ChunkContainer> Chunks = new List<ChunkContainer>();
        }
        #endregion
    }
}
