using System;
using System.Collections;
using System.Text;
using System.Windows.Forms;
namespace entity
{
    public sealed class MetaOverWriter
    {
        public static int SizeOfShift;
        public static int OffsetOfShift;
        public static int TagNumber;
        #region Methods
        public static void OverWrite(int mapnumber, int tagnumber,ref Meta meta)
        {
            TagNumber = tagnumber;
            if (Maps.map[mapnumber].MetaInfo.TagType[tagnumber] == "sbsp")
            {
                MessageBox.Show("Can't OverWrite The Bsp");
                return;
            }
            meta.RelinkReferences(mapnumber);
            ArrayList metas = new ArrayList(0);
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
            {
                if (tagnumber == x)
                {
                    meta.type = Maps.map[mapnumber].MetaInfo.TagType[x];
                    meta.name = Maps.map[mapnumber].FileNames.Name[x];
                    MetaOverWriter.SizeOfShift = meta.size - Maps.map[mapnumber].MetaInfo.Size[x];
                    metas.Add(meta);
                    continue;
                }

                Meta m = new Meta();
                m.ReadMetaFromMap(x, mapnumber, true);
                IFPIO ifpx = IFP.IFPHashMap.GetIfp(m.type,mapnumber);


                m.headersize = ifpx.headerSize;
                MetaScanner metaScanner = new MetaScanner();
                
                    metaScanner.ScanWithIFP(ref ifpx, ref m, mapnumber);
                    // metaScanner.ScanManually(ref m, ref map);
                
                metas.Add(m);
            }
    
            FixReflexives(metas, mapnumber);
            Maps.map[mapnumber].CloseMap();
        }
        
        public static void FixReflexives(ArrayList metas, int mapnumber)
        {
            int where = Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart;

            int howfar = 0;
            int[] oldoffset = (int[])Maps.map[mapnumber].MetaInfo.Offset.Clone();
            int padding = 0;
            for (int x = 0; x < metas.Count; x++)
            {
                Meta m = (Meta)metas[x];
                int fuck = Maps.map[mapnumber].IndexHeader.tagsOffset + (x * 16);
                int offset = oldoffset[x] + padding;
                if (x > ChunkAdder.TagNumber) { offset += ChunkAdder.SizeOfShift; }
                int offsetwithmagic = offset + Maps.map[mapnumber].SecondaryMagic;
                int size = m.size;
                if (m.type == "phmo" | m.type == "coll" | m.type == "spas")
                {
                    int tempoffset = offset;
                    do
                    {
                        string tempss = tempoffset.ToString("X");
                        char[] tempc = tempss.ToCharArray();
                        int xxx = tempc.Length;
                        if (m.padding == tempc[xxx - 1])
                        {
                            int diff = tempoffset - offset;
                            byte[] tempb = new byte[diff];
                            Maps.map[mapnumber].BW.BaseStream.Position = offset;
                            Maps.map[mapnumber].BW.Write(tempb);

                            int tempsize = ((Meta)metas[x - 1]).size;
                            tempsize += diff;
                            int temploc = Maps.map[mapnumber].IndexHeader.tagsOffset + ((x - 1) * 16) + 12;
                            Maps.map[mapnumber].BW.BaseStream.Position = temploc;
                            Maps.map[mapnumber].BW.Write(tempsize);


                            offset = tempoffset;
                            howfar += diff;
                            padding += diff;
                            break;
                        }
                        tempoffset++;
                    }
                    while (fuck != -54454);
                }



                if (m.type != "sbsp" && m.type != "ltmp")
                {

                }
                else
                {
                    continue;
                }
                howfar += size;

                Maps.map[mapnumber].BW.BaseStream.Position = offset;
                Maps.map[mapnumber].BW.BaseStream.Write(m.MS.ToArray(), 0, m.size);

                Maps.map[mapnumber].MetaInfo.Offset[x] = offset;
                // if (x == 0x334) { MessageBox.Show("test"); }
                //     if (x == 0) {
                //     map.BW.BaseStream.Position = fuck + 8;
                //    map.BW.Write(offsetwithmagic);
                //   map.BW.Write(size);
                //  continue; }

                //  if (oldoffset[x-1] == oldoffset[x]) {
                //     map.MetaInfo.Offset[x] = map.MetaInfo.Offset[x - 1];
                //}
                offsetwithmagic = Maps.map[mapnumber].MetaInfo.Offset[x] + Maps.map[mapnumber].SecondaryMagic;
                Maps.map[mapnumber].BW.BaseStream.Position = fuck + 8;
                Maps.map[mapnumber].BW.Write(offsetwithmagic);
                Maps.map[mapnumber].BW.Write(size);

            }

            for (int x = 0; x < metas.Count; x++)
            {
                Meta m = (Meta)metas[x];
                if (m.type == "sbsp" || m.type == "ltmp")
                {
                    continue;
                }
                int offset = Maps.map[mapnumber].MetaInfo.Offset[x];
                for (int xx = 0; xx < m.items.Count; xx++)
                {

                    Meta.Item i = (Meta.Item)m.items[xx];
                    switch (i.type)
                    {
                        case Meta.ItemType.Reflexive:
                            Meta.Reflexive reflex = (Meta.Reflexive)i;
                            int newreflex = reflex.translation + offset + Maps.map[mapnumber].SecondaryMagic;
                            if (reflex.intag != m.tagnumber) { continue; }
                            if (reflex.pointstotagnumber != m.tagnumber)
                            {
                                newreflex = Maps.map[mapnumber].MetaInfo.Offset[reflex.pointstotagnumber] + reflex.translation + Maps.map[mapnumber].SecondaryMagic;
                                //if (reflex.pointstotagnumber > ChunkAdder.TagNumber) { newreflex += ChunkAdder.SizeOfShift; }
                            }
                            Maps.map[mapnumber].BW.BaseStream.Position = offset + reflex.offset;
                            Maps.map[mapnumber].BW.Write(reflex.chunkcount);
                            Maps.map[mapnumber].BW.Write(newreflex);
                            break;

                    }

                }
            }
            int prevsize = Maps.map[mapnumber].MapHeader.fileSize - (Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart);
            int paddingx = Maps.map[mapnumber].Functions.Padding(howfar, 512);
            byte[] tempbb = new byte[paddingx];
            Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].MapHeader.metaStart + howfar;
            Maps.map[mapnumber].BW.Write(tempbb);
            howfar += paddingx;

            int sizediff = howfar - prevsize;
            int newfilesize = Maps.map[mapnumber].MapHeader.fileSize + sizediff;
            Maps.map[mapnumber].BW.BaseStream.Position = 8;
            Maps.map[mapnumber].BW.Write(newfilesize);
            int metasize = Maps.map[mapnumber].MapHeader.metaSize + sizediff;
            int combined = Maps.map[mapnumber].MapHeader.combinedSize + sizediff;
            Maps.map[mapnumber].BW.BaseStream.Position = 24;
            Maps.map[mapnumber].BW.Write(metasize);
            Maps.map[mapnumber].BW.Write(combined);
            Maps.map[mapnumber].FS.SetLength(newfilesize);

        }
        #endregion
    }
}
